/*
 * RRDISPLAY.CMD  by mira308sw
 *
 * WARNING!:
 *  this script work only with modified version of Builtins.out crc=19bb6041
 *  in which the function ExecuteFlasherOut can pass to called funptr till to
 *  seven integers (or addresses) parameters
 *
 * Rotate screen 180 for RT4 or RT5 device with sw:8.xx
 *
 * v 1.00: 02/06/2011   first release
 */

typedef unsigned char           BYTE;
typedef unsigned short          WORD;
typedef unsigned long           DWORD;

typedef enum { ERROR=-1,OK=0 }  STATUS;

STATUS  ShowNavigationQuestionScreen  ( char *txt, int *answ );
void    RebootSystem              ( void );
void*   UPGFindSymbol             ( char *sym );
int     ExecuteFlasherOut         ( void *funptr,... );   // max 7 parameters

/* these functions work only on modified Builtins.out crc=19bb6041
 */
#define EFO                     ExecuteFlasherOut


int   RotateDisplay  ( void )
{
  BYTE  l_displayPWD[6];
  void *l_fget = UPGFindSymbol( "InterGetDisplayPwd__FPUs" );
  void *l_fset = UPGFindSymbol( "InterSetDisplayPwd__FPCUs" );

  if( !l_fget || !l_fset )
    return ERROR;
  if( EFO( l_fget,l_displayPWD )!=OK )
    return ERROR;
  l_displayPWD[1] ^= 0x02;
  return EFO( l_fset,l_displayPWD );
}

int   main  ( int argc,char *argv[] )
{
  int   l_answ;

  ShowNavigationQuestionScreen( "Rotate Display ?",&l_answ );
  if( l_answ )
  {
    if( RotateDisplay()==OK )
    {
      ShowNavigationQuestionScreen( "Completed, now reboot!",&l_answ );
      RebootSystem();
    }
  }
  return OK;
}
